//+------------------------------------------------------------------+
//|                                                    cci_ma_ea.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//--- 
input int      StopLoss=30;      // ֹ
input int      TakeProfit=50;    // 
input int      MA_Period=26;     // MA 
input int      CCI_Period1=50;   // CCI  1
input int      CCI_Period2=28;   // CCI  2
input int      EA_Magic=999;     // EA 
input double   Lot=0.1;          // 
//--- 
int maHandle;                   // ƶƽָľ
int cciHandle1,cciHandle2;      //  CCI ָľ
double maVal[];                 // ƶƽÿֵ
double cciVal1[],cciVal2[];       // CCIÿֵ
double p1_close,p2_close;       //ֱ𱣴12̼۵ı
//--- һЩõֵ
double cczero = 0.0000;
double ccip = 1.0000;
double ccim = -1.0000;
double ccmaxa = 100.0000;
double ccmaxb = 95.0000;
double ccmina = -100.0000;
double ccminb = -95.0000;
int STP, TKP;        // ֹͻı
MqlRates mrate[];    // ڱÿļ۸񣬽͵
//+------------------------------------------------------------------+
//| EAʼ                                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- ƶƽָľ
   maHandle=iMA(_Symbol,Period(),MA_Period,0,MODE_EMA,PRICE_TYPICAL);
//--- CCIָ1ľ
   cciHandle1=iCCI(_Symbol,PERIOD_CURRENT,CCI_Period1,PRICE_TYPICAL);
//--- CCIָ2ľ
   cciHandle2=iCCI(_Symbol,PERIOD_CURRENT,CCI_Period2,PRICE_TYPICAL);
//--- õľЧ
   if(maHandle<0 || cciHandle1<0 || cciHandle2<0)
     {
      Alert("ָ - : ",GetLastError(),"!!");
     }
/*
     ȷϼ۸ݣADXֵMAֵ 
     ʱ͵
*/
// ۸
   ArraySetAsSeries(mrate,true);
// CCI 1 ֵ
   ArraySetAsSeries(cciVal1,true);
// CCI 2 ֵ
   ArraySetAsSeries(cciVal2,true);
// MA ֵ
   ArraySetAsSeries(maVal,true);

//--- Ǵṩ5λ3λ۸񣬶4λ۸Ľ׾
   STP = StopLoss;
   TKP = TakeProfit;
   if(_Digits==5 || _Digits==3)
     {
      STP = STP*10;
      TKP = TKP*10;
     }
   return(0);
  }
//+------------------------------------------------------------------+
//| EA ȥʼ                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- ͷǵָ
   IndicatorRelease(maHandle);
   IndicatorRelease(cciHandle1);
   IndicatorRelease(cciHandle2);
  }
//+------------------------------------------------------------------+
//| EA                                              |
//+------------------------------------------------------------------+
void OnTick()
  {
//--- Ƿ㹻ڴ
   int Mybars=Bars(_Symbol,_Period);
   if(Mybars<60) // 60
    {
      Alert("ֻв60, EA Ҫ˳!!");
      return;
     }

//--- һЩڽнҪʹõMQL5ṹ
   MqlTick latest_price;      // ڻý/±
   MqlTradeRequest mrequest;  // ڷǵĽ
   MqlTradeResult mresult;    // ڻǵĽ׽

//--- ʹ MQL5 MqlTick ṹ±
   if(!SymbolInfoTick(_Symbol,latest_price))     // 100
     {
      Alert("ȡ±۳ - :",GetLastError(),"!!");  // 103
      return;
     }

//--- ȡϸϢ
   if(CopyRates(_Symbol,_Period,0,3,mrate)<0)
     {
      Alert("Ƽ۸/ʷݳ - :",GetLastError(),"!!");
      return;
     }

//--- EAӦֻʱµĽ
//--- һ̬ datetime ͱ
   static datetime Prev_time;
//--- õǰĿʼʱ ( 0)
   datetime Bar_time[1];
//--- Ƶǰʱ
   Bar_time[0]=mrate[0].time;
//--- ʱͬʱ˵û
   if(Prev_time==Bar_time[0])
     {
      return;
     }
//--- һʱ䵽̬
   Prev_time=Bar_time[0];

//--- ʹþֵָƵ()
   if(CopyBuffer(maHandle,0,0,5,maVal)<0)
     {
      Alert("MAָ껺 - :",GetLastError(),"!!");
      return;
     }
   if(CopyBuffer(cciHandle1,0,0,5,cciVal1)<0 || CopyBuffer(cciHandle2,0,0,5,cciVal2)<0)
     {
      Alert("CCIָ껺 - :",GetLastError());
      return;
     }
//--- ûԼ
//--- ƵǰǰһҲ1̼
   p1_close=mrate[1].close;  // 1̼
   p2_close=mrate[2].close;  // 2̼

//--- ǷѾгֲ?
   bool Buy_opened=false,Sell_opened=false;
   if(PositionSelect(_Symbol)==true) // һĲλ
     {
      if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
        {
         Buy_opened=true;  //λ
         double msl=PositionGetDouble(POSITION_SL);
         double mtp=PositionGetDouble(POSITION_TP);
         if(CheckTrade("BUY")==true)
           {
            Buy_opened=false;
           }
        }
      else if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)   // 159
        {
         Sell_opened=true; // λ
         double smsl=PositionGetDouble(POSITION_SL);
         double smtp=PositionGetDouble(POSITION_TP);
         if(CheckTrade("SELL")==true)
           {
            Sell_opened=false;
           }
        }
     }

//--- boolͱǵ
   bool Buy_Condition_1=(cciVal1[3]<cczero) && (cciVal1[2]>cczero);    // CCI 1 ϴ0
   bool Buy_Condition_2=(p2_close>maVal[2]);                           // 2̼MA֮
   bool Buy_Condition_3=(p1_close>p2_close);                           // 1̼۱2̼۸
   bool Buy_Condition_4=(cciVal1[0]>ccip) && (cciVal2[0]>ccip);        // CCI 1  CCI 2 

//--- boolͱǵ
   bool Sell_Condition_1 = (cciVal1[3]>cczero) && (cciVal1[2]<cczero); // CCI 1 ´0
   bool Sell_Condition_2 = (p2_close < maVal[2]);                      // 2̼MA֮
   bool Sell_Condition_3=(p1_close<p2_close);                          // 1̼۱2̼۵
   bool Sell_Condition_4=(cciVal1[0]<ccim) && (cciVal2[0]<ccim);       // CCI 1  CCI 2 Ǹ 

/*
    1.  
*/
//--- һ   
   if(Buy_Condition_1 && Buy_Condition_2)
     {
      if(Buy_Condition_3 && Buy_Condition_4)
        {
//--- Ѿλ?
         if(Buy_opened)
           {
            Alert("Ѿλ!!!");
            return;    // µλ
           }
         mrequest.action = TRADE_ACTION_DEAL;                                   // ִж
         mrequest.price = NormalizeDouble(latest_price.ask,_Digits);            // 
         mrequest.sl = NormalizeDouble(latest_price.ask - STP*_Point,_Digits);  // ֹ
         mrequest.tp = NormalizeDouble(latest_price.ask + TKP*_Point,_Digits);  // 
         mrequest.symbol = _Symbol;                                             // Ҷ
         mrequest.volume = Lot;                                                 // 
         mrequest.magic = EA_Magic;                                             // 
         mrequest.type = ORDER_TYPE_BUY;                                        // 붩
         mrequest.type_filling = ORDER_FILLING_IOC;                             // Order execution type
         mrequest.deviation=100;                                                // ǰ۸ƫ
//--- Ͷ
         OrderSend(mrequest,mresult);
//--- ӽ׷ȡ÷ش
         if(mresult.retcode==10009 || mresult.retcode==10008) //ɻѾµ
           {
            Alert("ɹ붩#:",mresult.order,"!!");
           }
         else
           {
            Alert("붩δ-:",GetLastError());
            return;
           }
        }
     }
/*
    2.  : 
*/
//--- һ
   else if(Sell_Condition_1 && Sell_Condition_2)
     {
      if(Sell_Condition_3 && Sell_Condition_4)
        {
//--- Ѿλ?
         if(Sell_opened)
           {
            Alert("Ѿһλ!!!");
            return;    // µλ
           }
         mrequest.action = TRADE_ACTION_DEAL;                                   // ִж
         mrequest.price = NormalizeDouble(latest_price.bid,_Digits);            // ұ
         mrequest.sl = NormalizeDouble(latest_price.bid + STP*_Point,_Digits);  // ֹ
         mrequest.tp = NormalizeDouble(latest_price.bid - TKP*_Point,_Digits);  // 
         mrequest.symbol = _Symbol;                                             // Ҷ
         mrequest.volume = Lot;                                                 // 
         mrequest.magic = EA_Magic;                                             // 
         mrequest.type = ORDER_TYPE_SELL;                                       // 
         mrequest.type_filling = ORDER_FILLING_IOC;                             // Order execution type
         mrequest.deviation=100;                                                // ǰ۸ƫ
//--- Ͷ
         OrderSend(mrequest,mresult);
//--- ӽ׷ȡ÷ش
         if(mresult.retcode==10009 || mresult.retcode==10008) // ɻѾµ
           {
            Alert("ɹ#:",mresult.order,"!!");
           }
         else
           {
            Alert("δ -:",GetLastError());
            return;
           }
        }
     }
   return;
  }

//+------------------------------------------------------------------+
//|  ƽ                                     |
//+------------------------------------------------------------------+
bool checkClose(string ptype)
  {
   bool mark=false;
   if(ptype=="BUY")
     {
//--- ܷƽ˲λ
      if(cciVal1[2]>ccmaxa && cciVal1[1]<ccmaxb) // CCI I  +100
        {
         mark=true;
        }
     }
   if(ptype=="SELL")
     {
//--- ܷƽ˲λ
      if(cciVal1[2]<ccmina && cciVal1[1]>ccminb)// CCI 1  -100
        {
         mark=true;
        }
     }
   return(mark);
  }
//+------------------------------------------------------------------+
//|  齻                                                |
//+------------------------------------------------------------------+
bool CheckTrade(string otyp)
  {
   bool marker=false;
   for(int i=1; i<=PositionsTotal();i++)    // 292
     {
      if(PositionSelect(_Symbol)==true)
        {
         if(PositionGetInteger(POSITION_MAGIC)==EA_Magic && PositionGetString(POSITION_SYMBOL)==_Symbol) // ǵ EA
           {
//--- ܷرմ˶
            Alert("checkclose-",otyp," : ",checkClose(otyp));
            if(checkClose(otyp)==true)
              {
               double pvol = PositionGetDouble(POSITION_VOLUME);
               ulong pdev = 100;
               if(CloseTrade(otyp,pvol,pdev)==true)
                 {
                  marker=true;
                 }
              }
           }
        }
     }
   return(marker);
  }
//+------------------------------------------------------------------+
//|  رս                                                |
//+------------------------------------------------------------------+
bool CloseTrade(string otype,double vol,ulong dev)
  {
   MqlTradeRequest trequest;
   MqlTradeResult tresult;
   ENUM_ORDER_TYPE ptype;
   if(otype=="BUY")
     {
      ptype=ORDER_TYPE_SELL;
      trequest.price=SymbolInfoDouble(_Symbol,SYMBOL_BID);
     }
   else
     {
      ptype=ORDER_TYPE_BUY;
      trequest.price=SymbolInfoDouble(_Symbol,SYMBOL_ASK);
     }
   trequest.action=TRADE_ACTION_DEAL;
   trequest.type=ptype;
   trequest.volume=vol;
   trequest.sl=0;
   trequest.tp=0;
   trequest.deviation=dev;
   trequest.magic=EA_Magic;
   trequest.symbol=_Symbol;
   trequest.type_filling=ORDER_FILLING_FOK;
//--- 
   OrderSend(trequest,tresult);
//--
   if(tresult.retcode==10009 || tresult.retcode==10008) // ɹ 
     {
      Alert("ɹرһĲλ#:",tresult.order,"!!");
      return(true);
     }
   else
     {
      Alert("δɹرղλ - : ",GetLastError());
      return(false);
     }
  }
//+------------------------------------------------------------------+